

# BatchUpdateDetector
<a name="API_BatchUpdateDetector"></a>

**Important**  
End of support notice: On May 20,2026, Amazon will end support for Amazon IoT Events. After May 20,2026, you will no longer be able to access the Amazon IoT Events console or Amazon IoT Events resources. For more information, see [Amazon IoT Events end of support](https://docs.amazonaws.cn/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Updates the state, variable values, and timer settings of one or more detectors (instances) of a specified detector model.

## Request Syntax
<a name="API_BatchUpdateDetector_RequestSyntax"></a>

```
POST /detectors HTTP/1.1
Content-type: application/json

{
   "detectors": [ 
      { 
         "detectorModelName": "string",
         "keyValue": "string",
         "messageId": "string",
         "state": { 
            "stateName": "string",
            "timers": [ 
               { 
                  "name": "string",
                  "seconds": number
               }
            ],
            "variables": [ 
               { 
                  "name": "string",
                  "value": "string"
               }
            ]
         }
      }
   ]
}
```

## URI Request Parameters
<a name="API_BatchUpdateDetector_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_BatchUpdateDetector_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [detectors](#API_BatchUpdateDetector_RequestSyntax) **   <a name="ioteventsdata-BatchUpdateDetector-request-detectors"></a>
The list of detectors (instances) to update, along with the values to update.  
Type: Array of [UpdateDetectorRequest](API_UpdateDetectorRequest.md) objects  
Array Members: Minimum number of 1 item.  
Required: Yes

## Response Syntax
<a name="API_BatchUpdateDetector_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "batchUpdateDetectorErrorEntries": [ 
      { 
         "errorCode": "string",
         "errorMessage": "string",
         "messageId": "string"
      }
   ]
}
```

## Response Elements
<a name="API_BatchUpdateDetector_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [batchUpdateDetectorErrorEntries](#API_BatchUpdateDetector_ResponseSyntax) **   <a name="ioteventsdata-BatchUpdateDetector-response-batchUpdateDetectorErrorEntries"></a>
A list of those detector updates that resulted in errors. (If an error is listed here, the specific update did not occur.)  
Type: Array of [BatchUpdateDetectorErrorEntry](API_BatchUpdateDetectorErrorEntry.md) objects

## Errors
<a name="API_BatchUpdateDetector_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also
<a name="API_BatchUpdateDetector_SeeAlso"></a>

For more information about using this API in one of the language-specific Amazon SDKs, see the following:
+  [Amazon Command Line Interface V2](https://docs.amazonaws.cn/goto/cli2/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [Amazon SDK for .NET V4](https://docs.amazonaws.cn/goto/DotNetSDKV4/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [Amazon SDK for C\$1\$1](https://docs.amazonaws.cn/goto/SdkForCpp/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [Amazon SDK for Go v2](https://docs.amazonaws.cn/goto/SdkForGoV2/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [Amazon SDK for Java V2](https://docs.amazonaws.cn/goto/SdkForJavaV2/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [Amazon SDK for JavaScript V3](https://docs.amazonaws.cn/goto/SdkForJavaScriptV3/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [Amazon SDK for Kotlin](https://docs.amazonaws.cn/goto/SdkForKotlin/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [Amazon SDK for PHP V3](https://docs.amazonaws.cn/goto/SdkForPHPV3/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [Amazon SDK for Python](https://docs.amazonaws.cn/goto/boto3/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [Amazon SDK for Ruby V3](https://docs.amazonaws.cn/goto/SdkForRubyV3/iotevents-data-2018-10-23/BatchUpdateDetector) 